# Read built-in

The read built-in reads a line from the standard input.

## Syntax

- `read [-Ar] variable…`

## Description

The read built-in reads a line of string from the standard input and assigns it to the specified variables. If the shell is interactive and line-editing is enabled, you can use line-editing when inputting a line.

If the `-r` (`--raw-mode`) option is specified, all characters in the line are treated literally.

If the `-r` (`--raw-mode`) option is not specified, backslashes in the line are treated as quotations. If a backslash is at the end of the line, it is treated as a line continuation. When the built-in reads the next line, the `PS2` variable is used as a prompt if the standard input is a terminal.

The input line is subject to field splitting. The resulting words are assigned to variables in order. If there are more words than variables, the last variable is assigned all the remaining words (as if the words were not split). If the words are fewer than variables, the remaining variables are assigned empty strings.

## Options

`-A`
`--array`

  Make the last variable an array. Instead of assigning a concatenation of the remaining words to a normal variable, the words are assigned to an array.

`-r`
`--raw-mode`

  Don’t treat backslashes as quotations.

## Operands

variables

  Names of variables to which input words are assigned.

## Exit status

The exit status of the read built-in is zero unless there is any error.

## Notes

The read built-in is a semi-special built-in.

The POSIX standard defines the `-r` option only: other options cannot be used in the POSIXly-correct mode.